# lib/goog/net/xmlhttpfactory.js

    1// Copyright 2010 The Closure Library Authors. All Rights Reserved.2//3// Licensed under the Apache License, Version 2.0 (the "License");4// you may not use this file except in compliance with the License.5// You may obtain a copy of the License at6//7//      http://www.apache.org/licenses/LICENSE-2.08//9// Unless required by applicable law or agreed to in writing, software10// distributed under the License is distributed on an "AS-IS" BASIS,11// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.12// See the License for the specific language governing permissions and13// limitations under the License.1415/**16 * @fileoverview Interface for a factory for creating XMLHttpRequest objects17 * and metadata about them.18 * @author dbk@google.com (David Barrett-Kahn)19 */2021goog.provide('goog.net.XmlHttpFactory');2223/** @suppress {extraRequire} Typedef. */24goog.require('goog.net.XhrLike');25262728/**29 * Abstract base class for an XmlHttpRequest factory.30 * @constructor31 */32goog.net.XmlHttpFactory = function() {33};343536/**37 * Cache of options - we only actually call internalGetOptions once.38 * @type {Object}39 * @private40 */41goog.net.XmlHttpFactory.prototype.cachedOptions_ = null;424344/**45 * @return {!goog.net.XhrLike.OrNative} A new XhrLike instance.46 */47goog.net.XmlHttpFactory.prototype.createInstance = goog.abstractMethod;484950/**51 * @return {Object} Options describing how xhr objects obtained from this52 *     factory should be used.53 */54goog.net.XmlHttpFactory.prototype.getOptions = function() {55  return this.cachedOptions_ ||56      (this.cachedOptions_ = this.internalGetOptions());57};585960/**61 * Override this method in subclasses to preserve the caching offered by62 * getOptions().63 * @return {Object} Options describing how xhr objects obtained from this64 *     factory should be used.65 * @protected66 */67goog.net.XmlHttpFactory.prototype.internalGetOptions = goog.abstractMethod;